<template>
  <el-col :span="16" :offset="6">
    <el-form label-width="100px" ref="formRef" :model="form">
      <el-form-item
        label="审批建议"
        prop="reason"
        style="margin-bottom: 20px"
        :rules="{
          required: true,
          message: '请选择',
          trigger: 'change'
        }"
      >
        <el-input
          type="textarea"
          v-model="form.reason"
          placeholder="请输入审批建议"
        />
      </el-form-item>
    </el-form>
    <div style="margin-left: 10%; margin-bottom: 20px; font-size: 14px">
      <el-button
        icon="el-icon-edit-outline"
        type="success"
        size="mini"
        @click="handleAudit(1)"
      >通过
      </el-button>
      <el-button
        icon="el-icon-circle-close"
        type="danger"
        size="mini"
        @click="handleAudit(0)"
        v-if="!['starter'].includes(taskDefinitionKey)"
      >驳回
      </el-button>

      <el-dropdown @command="(command) => handleCommand(command)" style="margin-left: 30px;">
        <span class="el-dropdown-link">更多<i class="el-icon-arrow-down el-icon--right"></i></span>
        <el-dropdown-menu slot="dropdown">
          <el-dropdown-item command="cancel">作废</el-dropdown-item>
        </el-dropdown-menu>
      </el-dropdown>

      <!-- <el-button
        icon="el-icon-circle-close"
        type="danger"
        size="mini"
        @click="handleBackList"
        >退回
      </el-button> -->
      <!-- <el-button
        icon="el-icon-circle-close"
        type="danger"
        size="mini"
        @click="handleAudit(0)"
        v-if="taskDefinitionKey != 'productionSupervisorApprove1'"
        >不通过
      </el-button>
      <el-button
        icon="el-icon-edit-outline"
        type="primary"
        size="mini"
        v-if="taskDefinitionKey != 'productionSupervisorApprove1'"
        @click="handleUpdateAssignee"
        >转办
      </el-button> -->
    </div>
  </el-col>
</template>

<script>
import {cancel} from "@/api/bpm/components/financialManage/invoiceManage";
import {approveTaskWithVariables} from '@/api/bpm/task';

// 流程实例的详情页，可用于审批
export default {
  name: '',
  components: {
    //   Parser
  },
  props: {
    businessId: {
      default: ''
    },
    taskId: {
      default: ''
    },
    id: {
      default: ''
    },
    taskDefinitionKey: {
      default: ''
    }
  },
  data() {
    return {
      form: {
        technicianId: '',
        reason: '',

      },
      tabOptions: [
        {key: 'financeApprove', permissionType: 'update', name: '财务审批'},
      ],
    };
  },
  created() {
  },
  methods: {
    /** 处理转办审批人 */
    handleUpdateAssignee() {
      this.$emit('handleUpdateAssignee');
    },
    /** 退回 */
    handleBackList() {
      this.$emit('handleBackList');
    },

    async handleAudit(status) {
      let permissionType = this.tabOptions.find(item => item.key == this.taskDefinitionKey)?.permissionType
      if (permissionType === 'update') {
        const id = await this.getTableValue();
        if (typeof id !== 'string') return
      }
      await this._approveTaskWithVariables(status);
    },
    async _approveTaskWithVariables(status) {
      let variables = {
        pass: !!status
      };
      approveTaskWithVariables({
        id: this.taskId,
        reason: this.form.reason,
        variables
      }).then((res) => {
        if (res.data.code != '-1') {
          this.$emit('handleAudit', {
            status,
            title: status === 0 ? '驳回' : ''
          });
        }
      });
    },

    getTableValue() {
      return new Promise((resolve, reject) => {
        this.$emit('getTableValue', async (data) => {
          resolve(await data);
        });
      });
    },

    //更多
    handleCommand(command) {
      if (command === 'cancel') {
        this.$confirm("是否确认作废？", {
          type: 'warning',
          cancelButtonText: '取消',
          confirmButtonText: '确定'
        }).then(() => {
          cancel({
            id: this.taskId,
            reason: this.form.reason,
            businessId: this.businessId,
          }).then(() => {
            this.$emit('handleClose');
          }).catch(() => {
            this.$message.error("流程作废失败");
          });
        }).catch(() => {});
      }
    },

  }
};
</script>

<style lang="scss"></style>
